jQuery.fn.serializeAll = function() {
    return jQuery.param(this.serializeArrayAll());
}

jQuery.fn.serializeArrayAll = function() {
    return this.map(function(){
		return jQuery.nodeName(this, "form") ?
			    jQuery.makeArray(this.elements) : this;})
		.filter(function(){
			return this.name &&
				(this.checked || /select|textarea/i.test(this.nodeName) ||
					/text|hidden|password/i.test(this.type));
		})
		.map(function(i, elem){
			var val = jQuery(this).val();
			return val == null ? null :
				val.constructor == Array ?
					jQuery.map( val, function(val, i){
						return {name: elem.name, value: val};
					}) :
					{name: elem.name, value: val};
		}).get();
}

function form_callback_begin()
{
    $(document).lock({ parentID:'#main'});
}

function form_callback_end()
{
    $(document).unlock();
}

function form_callback(id,form,path,begin_cb,end_cb,async)
{
	var is_async = async || false;
	//reconstruct url: document.location.href can contain broken url, e.g. with ? at the end
	if (!path){
	    with (document.location)
		path = protocol + '//' + host + pathname + search
	}

	path=path + ((path.indexOf('?') == -1)?'?':'&') + 'ajax='+id+'&msienocache='+ Math.random();

	if (begin_cb) begin_cb(); else form_callback_begin();
	return jQuery.ajax({
		    type: 'POST',
		    async: is_async,
		    url: path,
		    data: form? $(form).serializeAll():$('form').serializeAll(),
		    dataType: 'text',
		    success: function(data) {
				if (end_cb) end_cb(); else form_callback_end() ;
				eval(data);
				},
		    error: function(xhr, status, expt) {
				alert("Async request failed\n"+
				      "Request status: "+status+"\n"+
				      "Response: "+xhr.responseText);
				if (end_cb) end_cb(); else form_callback_end() ;
				}
		});
}




function form_bind(name,event,id)
{
    var elt = $('input,select,textarea').filter('[name='+name+']');
    if (elt.length == 0) return;

    if (event == "enter")
	elt.bind("keypress", function(event) {
	    if (event.keyCode == 13) form_callback(id,elt[0].form);});
    else
	elt.bind( event, function() { form_callback(id,elt[0].form); });
}

function form_set_timeout(id, ms)
{
    function null_callback() { return 0; }
    setTimeout(function() { form_callback(id, document.form, null, null_callback, null_callback, true); }, ms);
}

jQuery.fn.resetOptions = function (data)
{
    return this.each(function(i)
    {
	var elt=$(this);

	elt.empty();
	for (var i=0;i<data.length;++i)
	{
	    var name = data[i]["name"];
	    var label = data[i]["label"] || name;

	    elt.append('<option value="'+name+'">'+label+'</option>');
	}
    });
}

jQuery.fn.resetCheckListRows = function (data)
{
    return this.each(function(i)
    {
	var elt=$(this);
	var elt_name=$(this).attr('name');

	elt.empty();
	for (var i=0;i<data.length;++i)
	{
	    var name = data[i]["name"];
	    var label = data[i]["label"] || name;

	    elt.append($('<tr><td><input type="checkbox" name="'+elt_name+'" value="'+name+'">'+label+'</td></tr>'));
	}
    });
}


function form_update_enum(name,data)
{
    $('select[name='+name+']').resetOptions(data);
    $('table[class=alterator-checklistbox][name='+name+']').resetCheckListRows(data);
}

jQuery.fn.updateValue = function(v)
{
    return this.each(function(i){
			var v1 = v;
			if (/radio|checkbox/.test(this.type))
			    v1 = v.split(";");
			$(this).val(v1);
		    });
}

jQuery.fn.updateProgress = function(v)
{
    return this.each(function(i){
			var slider = $('div[class=alterator-progress-slider]', this);
			if (!slider.length)
			{
			    slider = $('<div class="alterator-progress-slider"></div>');
			    slider.appendTo(this);
			}
			slider.css( { width: v + '%' } );
		    });
}

function form_update_value(name,value)
{
    $('input,select,textarea').filter('[name='+name+']').updateValue(value);
    $('span[class=alterator-label][name='+name+']').text(value);
    $('div[class=alterator-progress][name='+name+']').updateProgress(value);
}

function form_replace(path)
{
    document.location = path;
}

function form_update_visibility(name,status)
{
    var elt = $("[name="+name+"],span[nameref="+name+"]");

    if (status)
	elt.show();
    else
	elt.hide();
}

function form_update_activity(name,status)
{
    var elt = $("[name="+name+"],span[nameref="+name+"]");

    if (status)
	elt.removeClass('disabled');
    else
	elt.addClass('disabled');

    elt.each(function() { this.disabled = !status; });
}


function form_error(msg)
{
    alert(msg);
}

function form_warning(msg)
{
    alert(msg);
}

function form_type_error(reasonlist)
{
    var msg=[];
    for (var name in reasonlist)
    {
	    var label=$('span[nameref='+name+']').text();
	    if (!label) label=$('span[name='+name+']').text();
	    if (!label) label=name+':';
	    msg.push(label + reasonlist[name]);
    }
    alert(msg.join('\n'));
}

function form_update_cookie(name,value)
{
    $.cookie(name, value?value:null, { expires: new Date(2038, 0, 18) , path: '/' });
}

// initialization
$(document).ready(function() {
    form_callback('init');
    $('table.alterator-listbox').tablesorter({ widgets: ["zebra"] }); });
