/*** private */

var teInterval = 15000;

/*** date format */
function teNumberString(n)
{
    return (n < 10)? '0'+ n: n
}

function teString(clock)
{
    var date = clock.now;
    var h = date.getHours();
    var m = date.getMinutes();
    var s = date.getSeconds();

    return teNumberString(h) + ':'
	   +teNumberString(m) + ':'
	   +teNumberString(s);
}

/* date update */

function teValue(input)
{
    var v = input.val() || input.attr('value');//preffer real value
    var vlist = v.split(':');

    return new Date(1,1,1,
		    vlist[0] || 0,
		    vlist[1] || 0,
		    vlist[2] || 0);
}

function teSyncStart(clock,name)
{
    window.setTimeout (function () { teSyncClock(clock,name); },teInterval);
}

function teSyncClock(clock,name)
{
    if (clock.frozen)
	teSyncStart(clock,name);
    else
	ajaxSubmit(function(document)
	    {
		teUpdateClock(clock,document,name);
		teSyncStart(clock,name);
	    });
}

function teUpdateClock(clock,document,name)
{
    var new_input = $('input[name='+name+']',document);
    var real_input = $('input[name='+name+']');

    if (!new_input.length || !real_input.length)
	return;

    clock.now = teValue(new_input);
    clock.refreshDisplay();

    real_input.val(teString(clock));
}

/*** constructor */
function teCreate(name)
{
    var input = $('input[name='+name+']');
    var clock = new CoolClock(name+'-canvas');

    if (!clock || !input.length) return;

    //automatic update && freeze
    var hasFocus = false;
    var wasChanged = false;

    clock.onTick = function() { if (!hasFocus && !wasChanged) input.val(teString(this)); }
    input.focus(function() { hasFocus = true; clock.stop(); });
    input.blur(function() { hasFocus = false; if (!wasChanged) clock.start(); });
    input.change(function() { wasChanged = true; teUpdateClock(clock,document,name); });

    teUpdateClock(clock,document,name);
    teSyncStart(clock,name);
}

/* explorer canvas is ready to use only after page load */
function teCreateOnLoad(name)
{
    $(document).ready(function() { teCreate(name); });
}
