(define-module (ui login ajax)
    :use-module (alterator ahttpd)
    :use-module (alterator ajax)
    :use-module (alterator str)
    :use-module (alterator woo)
    :use-module (alterator session)
    :export (init))

(define *life-time* (* 60 60 3))

(define (update-locale)
  (form-update-cookie "language" (form-value "locale"))
  (form-replace "/login"))

(define (continue-path)
 (let ((path (form-value "continue")))
   (or (and (string? path)
            (not (string-null? path))
            (char=? (string-ref path 0) #\/)
            (not (uri-prefix? "/login" path))
            path)
        "/")))

(define (commit)
  (catch/message
    (lambda()
      (let ((login (form-value "login")))
	(woo-write "/login"
		   'login login
		   'password (form-value "password")
		   'language (form-value "language"))
	(form-update-cookie "session" (make-session login *life-time*))
	(form-replace (continue-path))))))

(define (init)
  (catch/message
    (lambda()
      (form-update-enum "locale" (woo-list "/login/avail_locale"))
      (form-update-value "locale" (car (string-cut (form-value "language") #\;)))
      (form-bind "locale" "change" update-locale)
      (form-bind "commit" "click" commit)
      (form-bind "password" "enter" commit))))

